import com.sun.jna.Native;

public class Test {
    static Boolean g_bAPIReturn = false;

    static void waitAPIReturn() throws InterruptedException
    {
        while (!g_bAPIReturn)
        {
            Thread.sleep(1000);
        }
        g_bAPIReturn = false;
    }

    static void testApi() throws InterruptedException
        {

            ViplexCore instance = (ViplexCore) Native.loadLibrary("viplexcore",ViplexCore.class);

            ViplexCore.CallBack callBack = new ViplexCore.CallBack() {

                @Override
                public void dataCallBack(int code, String data) {
                    // TODO Auto-generated method stub
                    String strCode = "\nViplexCore Demo code:" + code;
                    String strData = "\nViplexCore Demo data:" + data;
                    System.out.println(strCode);
                    System.out.println(strData);
                    g_bAPIReturn=true;
                }
                
            };

            String createProgram = "{\"name\":\"Demo\",\"width\":500,\"height\":500,\"tplID\":1,\"winInfo\":{\"height\":100,\"width\":100,\"left\":0,\"top\":0,\"zindex\":0,\"index\":0}}";
            String editProgram = "{\"programID\":1,\"pageID\":1,\"pageInfo\":{\"name\":\"jiemu\",\"widgetContainers\":[{\"audioGroup\":\"\",\"backgroundColor\":\"#00000000\",\"backgroundDrawable\":\"\",\"contents\":{\"widgetGroups\":[],\"widgets\":[{\"id\":1,\"enable\":true,\"repeatCount\":1,\"layout\":{\"y\":\"0\",\"height\":\"100%\",\"x\":\"0\",\"width\":\"100%\"},\"backgroundColor\":\"#00000000\",\"backgroundDrawable\":\"\",\"backgroundMusic\":\"\",\"zOrder\":0,\"displayRatio\":\"FULL\",\"outAnimation\":{\"type\":0,\"duration\":0},\"dataSource\":\"62ea7e60c493c1f860ae256eef8ec89c.png\",\"type\":\"PICTURE\",\"constraints\":[{\"cron\":[],\"endTime\":\"4017-12-30T23:59:59Z+8:00\",\"startTime\":\"1970-01-01T00:00:00Z+8:00\"}],\"border\":{\"borderThickness\":\"2px,3px,5%,6\",\"style\":0,\"backgroundColor\":\"#ff000000\",\"name\":\"border\",\"cornerRadius\":\"2%\",\"effects\":{\"headTailSpacing\":\"\",\"isHeadTail\":false,\"speedByPixelEnable\":true,\"speed\":0,\"animation\":\"CLOCK_WISE\"}},\"inAnimation\":{\"type\":0,\"duration\":1000},\"duration\":3605000,\"name\":\"test.png\",\"originalDataSource\":\"./test.png\",\"functionStorage\":\"\",\"isSupportSpecialEffects\":false}]},\"enable\":true,\"id\":1,\"itemsSource\":\"\",\"layout\":{\"height\":\"1.0\",\"width\":\"1.0\",\"x\":\"0.0\",\"y\":\"0.0\"},\"name\":\"widgetContainers1\",\"pickCount\":0,\"pickPolicy\":\"ORDER\",\"zOrder\":0}]}}";
            String genrateProgram = "{\"programID\":1,\"outPutPath\":\"./temp/\",\"mediasPath\":[{\"oldPath\":\"test\",\"newPath\":\"test\"}]}";
            String trasfromProgram = "{\"sn\": \"BZSA07313J0350001014\",\"iconPath\": \"\",\"iconName\": \"\",\"sendProgramFilePaths\": {\"programPath\": \"./temp/program1\",\"mediasPath\": {\"./test.png\": \"test.png\"}},\"programName\": \"program1\",\"deviceIdentifier\": \"Demo\",\"startPlayAfterTransferred\": true,\"insertPlay\": true}";
       
			String companyInfo = "{\"company\":\"NovaStar\",\"phone\":\"029-68216000\",\"email\":\"hr@novastar.tech\"}";
            System.out.println("nvInit(sdk 初始化):");
            System.out.println(instance.nvInit(System.getProperty("user.dir") + "/temp",companyInfo));
            System.out.println("ViplexCore Demo nvSearchTerminalAsync(搜索) begin... ");
            instance.nvSearchTerminalAsync(callBack);
            Thread.sleep(3000);
            g_bAPIReturn = false;

            // System.out.println("ViplexCore Demo nvSearchAppointIpAsync(指定IP搜索) begin... ");
            // String requestData = "{\"ip\":\"172.18.179.106\"}";
            // instance.nvSearchAppointIpAsync(requestData, callBack);
            // Thread.sleep(2000);

            System.out.println("ViplexCore Demo nvLoginAsync(登录) begin... ");
            instance.nvLoginAsync("{\"sn\":\"BZSA07313J0350001014\",\"username\":\"admin\",\"rememberPwd\":1,\"password\":\"12345678\",\"loginType\":0}",callBack);
            waitAPIReturn();

            System.out.println("ViplexCore Demo nvCreateProgramAsync(创建节目) begin... ");
            instance.nvCreateProgramAsync(createProgram, callBack);
            waitAPIReturn();


            String requestDatapath = "{\"filePath\":\"./test.png\"}";
            System.out.println("ViplexCore Demo nvGetFileMD5Async(获取MD5) begin... ");
            instance.nvGetFileMD5Async(requestDatapath, callBack);
            waitAPIReturn();

            System.out.println("ViplexCore Demo nvSetPageProgramAsync(编辑节目) begin... ");
            instance.nvSetPageProgramAsync(editProgram, callBack);
            waitAPIReturn();

            System.out.println("ViplexCore Demo nvMakeProgramAsync(生成节目) begin... ");
            instance.nvMakeProgramAsync(genrateProgram, callBack);
            waitAPIReturn();

            System.out.println("ViplexCore Demo nvStartTransferProgramAsync(发送节目) begin... ");
            instance.nvStartTransferProgramAsync(trasfromProgram, callBack);
            Thread.sleep(10000);
            g_bAPIReturn = false;

            System.out.println("ViplexCore Demo nvGetProgramInfoAsync(获取节目信息) begin... ");
            String requestDatasn = "{\"sn\":\"BZSA07313J0350001014\"}";
            instance.nvGetProgramInfoAsync(requestDatasn, callBack);
            waitAPIReturn();

            System.out.println("ViplexCore Demo nvSetVolumeAsync(设置音量) begin... ");
            instance.nvSetVolumeAsync("{\"sn\":\"BZSA07313J0350001014\",\"volumeInfo\":{\"ratio\":60.0}}", callBack);
            waitAPIReturn();

            System.out.println("ViplexCore Demo nvGetVolumeAsync(获取音量) begin... ");
            instance.nvGetVolumeAsync("{\"sn\":\"BZSA07313J0350001014\"}", callBack);
            waitAPIReturn();
        }

    public static void main(String[] args) throws InterruptedException{
        testApi();
    }
}
